#! /bin/perl
################################################
#
# rapatriement des logs WW
#
# version intgre a TBvirus
#
# J. VEHENT - juillet 2006
#

sub sub_rapatriement_logs(){

	# passage de paramtres : *retour est un pointeur a 0 si tout va bien et a -1 en cas de problme
	# $user et $pass servent pour la connection a SAV REPORTER
	local($DEBUG,*retour,$user,$pass)=@_;
	$retour=-1;

	open(DEBUG_FILE,">>.\\logs\\debug_TBvir.txt")or print "PLANTAGE COMPLET !!!! TUEZ L'APPLICATION\n";

	# MODIFICATION DU SIGNAL DIE
	#
	# ce code modifie l'excution d'un "die" en lui demandant d'crire dans les logs (si mode debug)
	# puis de passer la valeur retour a -1 (erreur d'excution) et enfin de mourrir (die classique)
	# =>tous les "die" de ce programme utiliseront le schma dcrit par le code ci-dessous
	local $SIG{'__DIE__'} = sub {	if($DEBUG==1){
						print DEBUG_FILE "SUB_RAPATRIEMENT_LOGS ==> $_[0]\n";
						close DEBUG_FILE;
					}
					$retour = -1;
					die $_[0];
				};

	my $cpt_fichier_copie=0;

	use File::Copy;

	####################################################################################################################################
	# RAPATRIEMENT DES LOGS WEBWASHER
	#
	#

	#Webwasher
	my $precedent_WW = "\\\\XXXXXXXX\\archives\\Log_WW\\Precedent\\";
	my $actuel_WW = "\\\\XXXXXXXX\\ftplogs\\Logs\\WW\\";
	my $destination_WW = "\\\\XXXXXXXXX\\secsi\\virus\\archivage\\Webwasher\\";

	opendir(DIR_PREC_WW,$precedent_WW) or eval{die"Impossible d'ouvrir le fichier $precedent_WW... $!\n"};
	opendir(DIR_ACTU_WW,$actuel_WW) or eval{die"Impossible d'ouvrir le rpertoire $actuel_WW... $!\n"};
	opendir(DEST_WW,$destination_WW) or eval{die"Impossible d'ouvrir le rpertoire $destination_WW... $!\n"};

	# copie des listes des fichiers dans deux tableaux
	my @fichiers_precedent_WW = readdir(DIR_PREC_WW);
	my @fichiers_actuels_WW = readdir(DIR_ACTU_WW);
	my @fichiers_destination_WW = readdir(DEST_WW);

	closedir DIR_PREC_WW;
	closedir DIR_ACTU_WW;
	closedir DEST_WW;

	# copie des fichiers dans la destination_WW si le fichier n'existe pas dj

	# 1ere boucle : traite les logs webwasher du mois precedent
	foreach $fichier_source (@fichiers_precedent_WW){

		if ($fichier_source =~/foundviruses/){
			# on ne prend pas les fichiers de logs du filtrage http
			unless($fichier_source =~/2\.log/){

				my $existe = 0;
	
				foreach $fichier_dest (@fichiers_destination_WW){
					if ($fichier_dest eq $fichier_source){
						if($DEBUG==1){print DEBUG_FILE "RAPATRIEMENT ==> le fichier $fichier_source est dj prsent dans secsi\n";}
						$existe = 1;
				}
			}

				if ($existe == 0){ #le fichier n'existe pas dans la destination_WW, on le copie
					if($DEBUG==1){print DEBUG_FILE "RAPATRIEMENT ==> copie de $fichier_source dans secsi\n";}
					copy($precedent_WW.$fichier_source, $destination_WW.$fichier_source) or eval{die"Impossible de copier le fichier $fichier_source... $!"};
					$cpt_fichier_copie++;
				}
			}
		}
	}

	# 2eme boucle : traite les logs webwasher du mois actuel
	foreach $fichier_source (@fichiers_actuels_WW){

		if ($fichier_source =~/foundviruses/){
			unless($fichier_source =~/2\.log/){

				my $existe = 0;
	
				foreach $fichier_dest (@fichiers_destination_WW){
					if ($fichier_dest eq $fichier_source){
						if($DEBUG==1){print DEBUG_FILE "RAPATRIEMENT ==> le fichier $fichier_source est deja present dans secsi\n";}
						$existe = 1;
					}
				}

				if ($existe == 0){ #le fichier n'existe pas dans la destination_WW, on le copie
					if($DEBUG==1){print DEBUG_FILE "RAPATRIEMENT ==> copie de $fichier_source dans secsi\n";}
					copy($actuel_WW.$fichier_source, $destination_WW.$fichier_source) or eval{die"Impossible de copier le fichier $fichier_source... $!"};
					$cpt_fichier_copie++;
				}
			}
		}
	}


	####################################################################################################################################
	# RAPATRIEMENT DES LOGS ANTIGEN
	#
	# ouverture du rep source, listage des fichiers, comparaison avec les fichiers dj prsent et copie des autres

	my $repanti = "\\\\m007700\\LogAntigen\\";
	my $destanti = "\\\\M001700\\secsi\\virus\\archivage\\Antigen\\";

	opendir(DIRANTI,$repanti) or eval{die "/!\\OUVERTURE DU REPERTOIRE $repanti A ECHOUEE/!\\\n$!"};
	my @lstanti = readdir(DIRANTI);
	close DIRANTI;

	opendir(DESTANTI,$destanti) or eval{die "/!\\OUVERTURE DU REPERTOIRE $destanti A ECHOUEE/!\\\n$!"};
	my @lstdestanti = readdir (DESTANTI);
	close DESTANTI;

	# pour chaque fichier source
	foreach $fichier_source (@lstanti){
		#si le fichier s'apelle "antigen"
		if ($fichier_source =~/antigen/){
			# on regarde s'il est dj prsent dans archive
			my $existe = 0;
			foreach $fichier_dest (@lstdestanti){
				if ($fichier_source eq $fichier_dest){
					if($DEBUG==1){print DEBUG_FILE "RAPATRIEMENT ==> le fichier $fichier_source est deja present dans secsi\n";}
					$existe = 1;
				}
			}
			# sinon, on le copie dans archive
			if ($existe==0){
				if($DEBUG==1){print DEBUG_FILE "RAPATRIEMENT ==> copie de $fichier_source dans secsi\n";}
				copy($repanti.$fichier_source, $destanti.$fichier_source) or eval{die"Impossible de copier le fichier $fichier_source... $!"};
				$cpt_fichier_copie++;
			}
		}
	}


	####################################################################################################################################
	# RAPATRIEMENT DES RAPPORTS MAILS ENTRANTS/SORTANTS
	#
	# rien de nouveau ... sauf le "unless (-s " qui compare les tailles des fichiers. Si le fichier source est plus gros que 
	# le fichier de destination, alors il crase ce dernier.

	my $repreport = "\\\\XXXXXXXXXXXX\\ftplogs\\logs\\reports\\";
	my $destreport = "\\\\XXXXXXXXXXXXX\\secsi\\virus\\archivage\\Report\\";

	opendir(REPORT,$repreport) or eval{die"Impossible d'ouvrir le rpertoire $repreport... $!"};
	my @lstreport = readdir(REPORT);
	close REPORT;

	opendir(DSTREPORT,$destreport)or eval{ die "Impossible d'ouvrir le rpertoire $destreport... $!"};
	@lstdestreport = readdir(DSTREPORT);
	close DSTREPORT;

	foreach $fichier_source (@lstreport){

		if ($fichier_source =~/report_mail/){

			my $existe = 0;
		
			foreach $fichier_dest (@lstdestreport){
				if ($fichier_dest eq $fichier_source){
					unless(-s $repreport.$fichier_source > -s $destreport.$fichier_dest){			
						if($DEBUG==1){print DEBUG_FILE "RAPATRIEMENT ==> le fichier $fichier_source est deja present dans secsi\n";}
						$existe = 1;
					}
				}
			}
			if ($existe == 0){ #le fichier n'existe pas dans la destination, on le copie
				if($DEBUG==1){print DEBUG_FILE "RAPATRIEMENT ==> copie de $fichier_source dans secsi\n";}
				copy($repreport.$fichier_source, $destreport.$fichier_source) or eval{die"Impossible de copier le fichier $fichier_source... $!"};
				$cpt_fichier_copie++;
			}
		}
	}

	####################################################################################################################################
	# RAPATRIEMENT DES LOGS NORTON SUR SAV REPORTER
	#
	# plus complexe ... on utilise les composants LWP pour se connecter en HTTP au serveur SAV REPORTER et rcuprer les logs
	# manquants jusqu' J-1
	#
	# la premiere tape est de regarder quels sont les logs manquants

	my $destnorton = "\\\\XXXXXXXXXXXX\\secsi\\virus\\archivage\\Norton\\";
	opendir(DSTNORTON,$destnorton) or eval{die"Impossible d'ouvrir le rpertoire $repreport... $!"};
	my @destnorton = readdir(DSTNORTON);
	close (DSTNORTON);

	my $last_date=0;
	foreach $fichdest (@destnorton){
		# on recherche la date du fichier le plus rcent
		# qui contient donc la dernire exploitation des logs
		if($last_date < substr($fichdest,23,8) ) {
			$last_date = substr($fichdest,23,8)
		}
	}

	if($DEBUG==1){print DEBUG_FILE "RAPATRIEMENT ==> les derniers logs norton datent de $last_date\n";}


	# on rcupre la date de j-1 (passage au moins prcdent si lanc le premier du mois)
	
	my @date = localtime();

	my $jfin = $date[3]-1;print $jfin;
	my $mfin = $date[4]+1;
	my $afin = $date[5]+1900;

	# si jfin n'est pas gal a 0, on vrifie juste la condition ci-dessous et on passe
	unless($jfin==0){
		if ($jfin<10){$jfin = "0".$jfin;}
	}
	else{	# on rcupre le dernier jour du mois prcdent
		if(0==($afin%4) and $mfin==3){	# <= test anne bisextile
			$jfin=29;
			$mfin="02";
		}
		else {
			if($mfin==1){$jfin=31;$mfin=12;$afin--;} # <=test premier janvier (!)
			else {
				if($mfin==2 or $mfin==4 or $mfin==6 or $mfin==8 or $mfin==9 or $mfin==11){$jfin=31;$mfin--;} #<= test mois a 30 jours
				else {	if($mfin==5 or $mfin==7 or $mfin==10 or $mfin==12){$jfin=30;$mfin--;}#<=test mois a 31 jours
					else { $jfin=28;$mfin--; #<=fevrier
					}
				}
			}
		}
	}


	if ($mfin<10){$mfin = "0".$mfin;}

	my $j_moins_un = $afin.$mfin.$jfin;

	# $last_date contient la date des logs les plus rcent.
	# si ces logs sont plus anciens que J-1, on lance une 
	# rcupration sur le serveur SAV REPORTER
	if($last_date > $j_moins_un){
		eval{die "ERREUR DE COHERENCE : la derniere exploitation norton est plus rcente que $j_moins_un... !!!"};
	}
	# on lance l'exploitation sur la priode manquante,
	# c'est  dire de ($last_date+1) a $j_moins_un
	if($last_date < $j_moins_un){
	
		######
		# cration de la date de dbut d'exploitation a partir de $last_date
		# on s'assure de passer au mois suivant si besoin
		my $jdeb = substr($last_date,6,2);
		my $mdeb = substr($last_date,4,2);
		my $adeb = substr($last_date,0,4);

		# mois a 30 jours
		if(($jdeb == 30) and (($mdeb==4)or($mdeb==6)or($mdeb==9)or($mdeb==11))){
			$jdeb="01"; $mdeb++;
			if($mdeb !~ /0/ and $mdeb <10){$mdeb="0".$mdeb;}
		}
		else {
			# mois a 31 jours
			if(($jdeb == 31) and (($mdeb==1)or($mdeb==3)or($mdeb==5)or($mdeb==7)or($mdeb==8)or($mdeb==10)or($mdeb==12))){
				# si la derniere exp date de dcembre, on passe
				# a l'anne suivante
				if($mdeb==12){
					$adeb++; $mdeb="01"; $jdeb="01";
				}
				else{
					$jdeb="01"; $mdeb++;
					if($mdeb !~ /0/ and $mdeb <10){$mdeb="0".$mdeb;}
				}
			}
			else {
				# fevrier bisextile
				if($mdeb==2 and $jdeb==29){
					$jdeb="01"; $mdeb++;
					if($mdeb !~ /0/ and $mdeb <10){$mdeb="0".$mdeb;}
				}	# fevrier non bisextile
				else{ 	if ($mdeb==2 and $jdeb==28 and (0 != ($adeb % 4))){
					$jdeb="01"; $mdeb++;
					if($mdeb !~ /0/ and $mdeb <10){$mdeb="0".$mdeb;}
					}
					else { # SI CE N'EST AUCUN DES CAS PRECEDENTS... on incrmente simplement la journe
						$jdeb++;
						if($jdeb !~ /0/ and $jdeb <10){$jdeb="0".$jdeb;}
					}
				}
			}
		}

		
		if($DEBUG==1){print DEBUG_FILE "RAPATRIEMENT ==> Rcupration par HTTP des logs norton de $adeb$mdeb$jdeb a $afin$mfin$jfin\n";}

		# URL de connection
		my $baseurl = 'http://XXXXXXXXXXXXXX/SAV%20Reporter';

		# initialisation de l'agent (le navigateur)
		my $ua = LWP::UserAgent->new( agent => 'Script perl de recup des logs',);

		# conservation du cookie de session dans un espace temporaire
		$ua->cookie_jar({});

		######
		#creation de la requete 1 : authentification sur SAV Reporter via un formulaire
		my $req = HTTP::Request->new( GET => "${baseurl}/Login/Login.php?destination=../events/events.php" );

		# execute la requete et recoit la rponse
		my $rep = $ua->request($req);
		die $rep->status_line if not $rep->is_success;

		# le formulaire de login est le premier formulaire de la page
		my $form = (HTML::Form->parse( $rep->content, $baseurl) ) [0];

		# on remplit les champs
		$form->find_input('user_name_tmp')->value($user);
		$form->find_input('password_tmp')->value($pass);

		# valide et renvoie le formulaire
		$rep = $ua->request( $form->click );
		if($DEBUG==1){print DEBUG_FILE "RAPATRIEMENT ==> Authentification HTTP sur SAV Reporter ...\n";}


		######
		# Requete 2 : incluant la priode d'exploitation et l'export vers un fichier csv
		$req = HTTP::Request->new( GET => "${baseurl}/events/export_events.php?filDayFrom=${jdeb}&filMonthFrom=${mdeb}&filYearFrom=${adeb}&filHourFrom=00&filMinFrom=00&filDayTo=${jfin}&filMonthTo=${mfin}&filYearTo=${afin}&filHourTo=23&filMinTo=59&filAlert=%25&filAction=%25&filSource=r%25%2Co%25%2Cq%25%2Cblank&limit=20&timebase=Alertdatetime&filServergroupname=%25&filClientgroupname=%25&filParentserverName=%25&filComputerName=%25&filIPAddress=%25&filClientuser=%25&filFromuser=%25&filVirusname=%25&filCategory=%3E%3D+-1&filType=%25virus%25%2C+%25worm%25%2C+%25trojan%25%2C+%25macro%25%2C+%25other%25%2C+%25unknown%25&filFilepath=%25&excServergroupname=0&excParentserverName=0&excComputerName=0&excIPAddress=0&excClientuser=0&excFromuser=&excClientgroupname=0&excVirusname=0&excVirustype=0&excFilepath=0&Notag_IDX=&sortorder=Alertdatetime&sortdir=desc&portion=&image.x=7&image.y=11&extension=csv&sep=%3B" );

		# execute la requete et recoit la rponse
		$rep = $ua->request($req);
		die $rep->status_line if not $rep->is_success;

		if($DEBUG==1){print DEBUG_FILE "RAPATRIEMENT ==> Requte de rcupration des logs pour la priode\n";}

		######
		# Requete 3 : il ne reste plus qu'a aller chercher le fichier de sortie fraichement gnr
		$req = HTTP::Request->new( GET =>"${baseurl}/temp/events.csv");

		# execute la requete et recoit la rponse
		$rep = $ua->request($req);
		die $rep->status_line if not $rep->is_success;

		# spcifie un nom pour le fichier contenant la priode exploite
		my $nomfich = "savreporter_".$adeb.$mdeb.$jdeb."_a_".$afin.$mfin.$jfin.".csv";
		# crit le fichier
		my $fichdestnorton = $destnorton.$nomfich;
		open (FICHDEST,">$fichdestnorton") or eval{die"Impossible d'ouvrir le fichier $destnorton$nomfich... $!"};
		print FICHDEST $rep->content;
		close FICHDEST;

		if($DEBUG==1){print DEBUG_FILE "RAPATRIEMENT ==> Tlchargement des rsultats dans $destnorton$nomfich\n";}

		# et enfin, incrmente le compteur
		$cpt_fichier_copie++;
		if($DEBUG==1){print DEBUG_FILE "RAPATRIEMENT ==> Rcupration des logs Norton .......OK\n";}

	}
	else {
		if($DEBUG==1){print DEBUG_FILE "RAPATRIEMENT ==> Pas de rcupration ncessaire des logs Norton\n";}
	}

	###################
	#
	# FIN DU SCRIPT DE RAPATRIEMENT
	#

	#on sors sans erreur en renvoyant le nombre de fichier copis
	$retour=0;
	close DEBUG_FILE;
	return $cpt_fichier_copie;

}

